% dlt.m    31-oct-02
% do resect of postcard looking southwest across engr. mall
%
%     L1X + L2Y + L3Z + L4
% x = ---------------------
%     L9X + L10Y + L11Z + 1
%
%     L5X + L6Y + L7Z + L8
% y = --------------------
%     L9X + L10Y + L11Z + 1
%
% x=[X Y Z 1 0 0 0 0 xX xY xZ] [  L1 ]
% y=[0 0 0 0 X Y Z 1 yX yY yZ] [  L2 ]
%                              [  L3 ]
%                              [  L4 ]
%                              [  L5 ]
%                              [  L6 ]
%                              [  L7 ]
%                              [  L8 ]
%                              [  L9 ]
%                              [ L10 ]
%                              [ L11 ] 
%

load control.dat
load obs.dat
Xref=control(1,2);
Yref=control(1,3);
Zref=control(1,4);
% initial princ. point: center of postcard
xpp=1000;
ypp=664;

[npts,ndum]=size(control);
xpho=zeros(npts,1);
ypho=zeros(npts,1);

B=zeros(2*npts,11);
f=zeros(2*npts,1);
for i=1:npts
  X=control(i,2) - Xref;
  Y=control(i,3) - Yref;
  Z=control(i,4) - Zref;
  x=obs(i,2)-xpp; % photoshop-x 
  y=-obs(i,3)+ypp; % photoshop-y 
  xpho(i)=x;
  ypho(i)=y;
  ii=(2*i)-1;
  B(ii  ,:)=[X Y Z 1 0 0 0 0 x*X x*Y x*Z];
  B(ii+1,:)=[0 0 0 0 X Y Z 1 y*X y*Y y*Z];
  f(ii  )=x;
  f(ii+1)=y;
  end

del=inv(B'*B)*B'*f;
resid=f - B*del;

del
resid

L=del;
P= -sqrt(1/(L(9)^2 + L(10)^2 + L(11)^2));
L1p=L(1)*(-P);
L2p=L(2)*(-P);
L3p=L(3)*(-P);
cx=sqrt(L1p^2+L2p^2+L3p^2);
L5p=L(5)*(-P);
L6p=L(6)*(-P);
L7p=L(7)*(-P);
cy=sqrt(L5p^2+L6p^2+L7p^2);
m31= -L(9)*P;
m32= -L(10)*P;
m33= -L(11)*P;
m11=L1p/cx;
m12=L2p/cx;
m13=L3p/cx;
m21=L5p/cy;
m22=L6p/cy;
m23=L7p/cy;
L4p=L(4)*P/cx;
L8p=L(8)*P/cy;
mx=[-m31 -m32 -m33;
     m11  m12  m13;
     m21  m22  m23];
vc=[P;L4p;L8p];
expsta=inv(mx)*vc;
EL=expsta(1) + Xref;
NL=expsta(2) + Yref;
hL=expsta(3) + Zref;
rm=[m11 m12 m13;m21 m22 m23;m31 m32 m33];
ident=rm*rm'
cx
cy
EL
NL
hL
rm
ident
phi=asin(m31);
cp=cos(phi);
kap=atan2(-m21/cp,m11/cp);
omg=atan2(-m32/cp,m33/cp);
omg
phi
kap

% write out a resect.inp format file

scr=zeros(npts,6);
for i=1:npts
  scr(i,:)=[obs(i,1) xpho(i) ypho(i) control(i,2:4)];
  end
scrt=scr';
fid=fopen('resect.inp','wt');
fprintf(fid,'%4.0f %6.0f %6.0f %12.1f %12.1f %8.1f\n',scrt);
fclose(fid);

