% lsq_res.m 11-dec-00 
% do nonlinear least squares with function collin
% which evaluates the collinearity equations at current
% parameter estimates, use numerical approximation of
% partial derivatives
function par = lsq_res(ep,pdel,ip,pname,x,y,X,Y,Z)

[xm,xn]=size(x);
numpar=6;
numpnt=xm;
numeqn=numpnt*2;

B=zeros(numeqn,numpar);
f=zeros(numeqn,1);

for iteration=1:10
  iteration
  for i=1:numpnt
    eqn=(i-1)*2 + 1;
    F0=collin(ep,ip,x(i),y(i),X(i),Y(i),Z(i));
    for j=1:numpar
      ep2=ep;
      ep2(j)=ep(j) + pdel(j);
      F1=collin(ep2,ip,x(i),y(i),X(i),Y(i),Z(i));
      B(eqn,  j)=(F1(1)-F0(1))/pdel(j);
      B(eqn+1,j)=(F1(2)-F0(2))/pdel(j);
      end;
    f(eqn)  =-F0(1);
    f(eqn+1)=-F0(2);
    end;
  N=B'*B;
  t=B'*f;
  Ninv=inv(N);
  del=Ninv*t;
  del
  ep=ep+del;
  converge=1;
  if (all(abs(del) < pdel))
    break
    end
  end

Qxx=Ninv;
vtv=0;
xhat=zeros(numpnt,1);
yhat=zeros(numpnt,1);
disp('residuals');
for i=1:numpnt
  disp(pname(i));
  F0=collin(ep,ip,x(i),y(i),X(i),Y(i),Z(i));
  F0
  xhat(i)=x(i) - F0(1);
  yhat(i)=y(i) - F0(2);
  vtv=vtv + F0(1)^2 + F0(2)^2;
  end;
par=ep;
r=2*numpnt-6;
sig0_sqr=vtv/r;
sig0=sqrt(sig0_sqr);
sig0
Sigxx=sig0_sqr*Qxx;
Sigxx

