% resect.m 11-dec-00
% perform space resection using purdue photo 18
 
degrad=180/pi;
ep=zeros(6,1);
pdel=zeros(6,1);
ip=zeros(3,1);

load cam.inp;

ep(1)=cam(1);
ep(2)=cam(2);
ep(3)=cam(3);
ep(4)=cam(4);
ep(5)=cam(5);
ep(6)=cam(6);

% inner orientation data f,xo,yo

ip(1)=cam(7);
ip(2)=cam(8);
ip(3)=cam(9);

% deltas for numerical estimate of parameter
% partial derivatives

pdel(1)=4.8e-06;
pdel(2)=4.8e-06;
pdel(3)=4.8e-06;
pdel(4)=1.0e-03;
pdel(5)=1.0e-03;
pdel(6)=1.0e-03;

% read input data, text file
% point name, photo-x,y ground X,Y,Z
[pname,x,y,X,Y,Z]=textread('resect.inp','%s %f %f %f %f %f');

% call the function to perform newton iteration
% with least squares estimation of corrections

par=lsq_res(ep,pdel,ip,pname,x,y,X,Y,Z);
format long
par


